// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Cv2xData.cpp
 * This source file contains the implementation of the described types in the IDL file.
 *
 * This file was generated by the tool fastddsgen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Cv2xData.h"

#include <fastcdr/Cdr.h>


#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>






Cv2xData::Cv2xData()
{
}

Cv2xData::~Cv2xData()
{
}

Cv2xData::Cv2xData(
        const Cv2xData& x)
{
    m_len = x.m_len;
    m_src_id = x.m_src_id;
    m_msg = x.m_msg;
}

Cv2xData::Cv2xData(
        Cv2xData&& x) noexcept
{
    m_len = x.m_len;
    m_src_id = std::move(x.m_src_id);
    m_msg = std::move(x.m_msg);
}

Cv2xData& Cv2xData::operator =(
        const Cv2xData& x)
{

    m_len = x.m_len;
    m_src_id = x.m_src_id;
    m_msg = x.m_msg;
    return *this;
}

Cv2xData& Cv2xData::operator =(
        Cv2xData&& x) noexcept
{

    m_len = x.m_len;
    m_src_id = std::move(x.m_src_id);
    m_msg = std::move(x.m_msg);
    return *this;
}

bool Cv2xData::operator ==(
        const Cv2xData& x) const
{
    return (m_len == x.m_len &&
           m_src_id == x.m_src_id &&
           m_msg == x.m_msg);
}

bool Cv2xData::operator !=(
        const Cv2xData& x) const
{
    return !(*this == x);
}

/*!
 * @brief This function sets a value in member len
 * @param _len New value for member len
 */
void Cv2xData::len(
        uint32_t _len)
{
    m_len = _len;
}

/*!
 * @brief This function returns the value of member len
 * @return Value of member len
 */
uint32_t Cv2xData::len() const
{
    return m_len;
}

/*!
 * @brief This function returns a reference to member len
 * @return Reference to member len
 */
uint32_t& Cv2xData::len()
{
    return m_len;
}


/*!
 * @brief This function copies the value in member src_id
 * @param _src_id New value to be copied in member src_id
 */
void Cv2xData::src_id(
        const std::array<uint8_t, 3>& _src_id)
{
    m_src_id = _src_id;
}

/*!
 * @brief This function moves the value in member src_id
 * @param _src_id New value to be moved in member src_id
 */
void Cv2xData::src_id(
        std::array<uint8_t, 3>&& _src_id)
{
    m_src_id = std::move(_src_id);
}

/*!
 * @brief This function returns a constant reference to member src_id
 * @return Constant reference to member src_id
 */
const std::array<uint8_t, 3>& Cv2xData::src_id() const
{
    return m_src_id;
}

/*!
 * @brief This function returns a reference to member src_id
 * @return Reference to member src_id
 */
std::array<uint8_t, 3>& Cv2xData::src_id()
{
    return m_src_id;
}


/*!
 * @brief This function copies the value in member msg
 * @param _msg New value to be copied in member msg
 */
void Cv2xData::msg(
        const std::vector<uint8_t>& _msg)
{
    m_msg = _msg;
}

/*!
 * @brief This function moves the value in member msg
 * @param _msg New value to be moved in member msg
 */
void Cv2xData::msg(
        std::vector<uint8_t>&& _msg)
{
    m_msg = std::move(_msg);
}

/*!
 * @brief This function returns a constant reference to member msg
 * @return Constant reference to member msg
 */
const std::vector<uint8_t>& Cv2xData::msg() const
{
    return m_msg;
}

/*!
 * @brief This function returns a reference to member msg
 * @return Reference to member msg
 */
std::vector<uint8_t>& Cv2xData::msg()
{
    return m_msg;
}


// Include auxiliary functions like for serializing/deserializing.
#include "Cv2xDataCdrAux.ipp"

